type: prog

uuid: 00009103-1b43-0520-2022-111400000008

titre: Les conditions utilisant les expressions régulières - les occurrences

niveau: Intermédiaire

description: Utiliser les occurrences de caractères dans une expression régulière.

énoncé: |
  Précédemment vous avez utilisé le symbole `?` qui spécifie que le caractère qui précède n'apparait pas (0 occurrence) ou apparait une fois (1 occurrence).  Le `?` est équivalent à `{0,1}`.  Deux autres symboles existent aussi: le `*` qui est équivalent à `{0,}` (donc de 0 à plusieurs occurrences) et le `+` qui est équivalent à `{1,}` (donc au moins une occurrence).  Vous devez maintenant valider, avec une seule expression régulière, des adresses courriels qui peuvent être dans les formats suivants: (a) bananepoilue@outlook.com (b) mon.prenom@yahoo.ca (c) uber_taxi@domaine.com (d) stageinformatique@crosemont.qc.ca (e) le_prof_informatique@enseignement.collegial.edu.  Bien entendu, l'adresse débute au début de la chaine de caractères et doit terminer la chaine de caractères.  N'oubliez pas que les espaces ne sont pas permis dans les adresses de courriels.  Pour simplifier l'exercice, seuls le point `.` et le souligné `_` sont permis comme caractères particuliers dans l'adresse de courriel.  Particularité: le point `.` est un caractère spécial dans l'expression régulière.  Pour obtenir le caractère point `.` il faut le précéder par le caractère d'échappement.

  À faire:

  1. Construire l'expression régulière pour que la condition `IF` fonctionne comme demandé.  La variable qui contient l'information à analyser est `Courriel`.
  2. Exécuter le script et corriger les erreurs s'il y a lieu.

  indice: Pour cette série d'exercices sur les expresions régulières, référez-vous au site [RegEx](https://docs.microsoft.com/fr-fr/powershell/module/microsoft.powershell.core/about/about_regular_expressions).  Attention: `-like` et `-match` ne sont pas des opérateurs identiques.  Pour utiliser des expressions régulières, il faut utiliser `-match`.

ébauches:
    powershell: !include exec.powershell

rétroactions:
    positive: Bravo! tu as réussi à créer une condition complexe utilisant les expressions régulières!
    négative: Référez-vous au site [RegEx](https://docs.microsoft.com/fr-fr/powershell/module/microsoft.powershell.core/about/about_regular_expressions).

tests: !include tests.yml

auteur: Gilles Lacasse
licence: 2022 CC-BY-SA
